searchNodes=[{"doc":"Documentation for ExCurl . Shared options :headers - a map of headers to include in the request, defaults to %{&quot;user-agent&quot; =&gt; &quot;curl/7.85.0&quot;} :body - a string to send as the request body, defaults to &quot;&quot; :follow_location - if redirects should be followed, defaults to true :ssl_verifyhost - if SSL certificates should be verified, defaults to true :ssl_verifypeer - if SSL certificates should be verified, defaults to true :return_metrics - if request timing metrics should be included in the returned results, defaults to false :verbose - if curl should output verbose logs to stdout, useful for debugging. Defaults to false :http_auth_negotiate - if curl should use HTTP Negotiation (SPNEGO) as defined in RFC 4559 . Note: this flag requires curl to be compiled with a suitable GSS-API or SSPI library. Defaults to false Error messages Error messages refer to error codes on the curl error codes documentation page . For example, when we try to send a request to an invalid url: iex&gt; ExCurl . get ( &quot;https://&quot; ) { :error , &quot;URL_MALFORMAT&quot; } The returned error tuple includes the error message &quot;URL_MALFORMAT&quot; . This corresponds to the CURLE_URL_MALFORMAT (error code 3) error listed in the curl error codes documentation .","ref":"ExCurl.html","title":"ExCurl","type":"module"},{"doc":"Sends a DELETE request to the given url . Similar to delete/2 but raises ExCurl.CurlError if the request fails. See the &quot;Shared options&quot; section at the module documentation for available options and their defaults. Examples iex&gt; ExCurl . delete! ( &quot;https://httpbin.org/delete&quot; )","ref":"ExCurl.html#delete!/2","title":"ExCurl.delete!/2","type":"function"},{"doc":"Sends a DELETE request to the given url . Returns either {:ok, %ExCurl.Response{}} or {:error, &quot;CURL_ERROR_MESSAGE&quot;} . See the &quot;Shared options&quot; section at the module documentation for available options and their defaults. See the &quot;Error messages&quot; section for details on error messages. Examples iex&gt; ExCurl . delete ( &quot;https://httpbin.org/delete&quot; , headers : %{ &quot;authentication&quot; =&gt; &quot;bearer secret&quot; } )","ref":"ExCurl.html#delete/2","title":"ExCurl.delete/2","type":"function"},{"doc":"Sends a GET request to the given url . Similar to get/2 but raises ExCurl.CurlError if the request fails. See the &quot;Shared options&quot; section at the module documentation for available options and their defaults. Examples iex&gt; % ExCurl.Response { status_code : status_code } = ExCurl . get! ( &quot;https://google.com&quot; ) iex&gt; status_code 200","ref":"ExCurl.html#get!/2","title":"ExCurl.get!/2","type":"function"},{"doc":"Sends a GET request to the given url . Returns either {:ok, %ExCurl.Response{}} or {:error, &quot;CURL_ERROR_MESSAGE&quot;} . See the &quot;Shared options&quot; section at the module documentation for available options and their defaults. See the &quot;Error messages&quot; section for details on error messages. Examples iex&gt; { :ok , % ExCurl.Response { status_code : status_code } } = ExCurl . get ( &quot;https://google.com&quot; , follow_location : false ) iex&gt; status_code 301 iex&gt; ExCurl . get ( &quot;https:// \\n \\n &quot; ) { :error , &quot;URL_MALFORMAT&quot; }","ref":"ExCurl.html#get/2","title":"ExCurl.get/2","type":"function"},{"doc":"Sends a PATCH request to the given url . Similar to patch/2 but raises ExCurl.CurlError if the request fails. See the &quot;Shared options&quot; section at the module documentation for available options and their defaults. Examples iex&gt; ExCurl . patch! ( &quot;https://httpbin.org/patch&quot; , body : Jason . encode! ( %{ &quot;some-value&quot; =&gt; true } ) , headers : %{ &quot;content-type&quot; =&gt; &quot;application/json&quot; } )","ref":"ExCurl.html#patch!/2","title":"ExCurl.patch!/2","type":"function"},{"doc":"Sends a PATCH request to the given url . Returns either {:ok, %ExCurl.Response{}} or {:error, &quot;CURL_ERROR_MESSAGE&quot;} . See the &quot;Shared options&quot; section at the module documentation for available options and their defaults. See the &quot;Error messages&quot; section for details on error messages. Examples iex&gt; ExCurl . patch ( &quot;https://httpbin.org/patch&quot; , headers : %{ &quot;user-agent&quot; =&gt; &quot;custom-user-agent&quot; } )","ref":"ExCurl.html#patch/2","title":"ExCurl.patch/2","type":"function"},{"doc":"Sends a POST request to the given url . Similar to post/2 but raises ExCurl.CurlError if the request fails. See the &quot;Shared options&quot; section at the module documentation for available options and their defaults. Examples iex&gt; ExCurl . post! ( &quot;https://httpbin.org/post&quot; , body : &quot;some-value=true&quot; )","ref":"ExCurl.html#post!/2","title":"ExCurl.post!/2","type":"function"},{"doc":"Sends a POST request to the given url . Returns either {:ok, %ExCurl.Response{}} or {:error, &quot;CURL_ERROR_MESSAGE&quot;} . See the &quot;Shared options&quot; section at the module documentation for available options and their defaults. See the &quot;Error messages&quot; section for details on error messages. Examples iex&gt; { :ok , % ExCurl.Response { body : body } } = ExCurl . post ( &quot;https://httpbin.org/post&quot; , body : &quot;some-value=true&quot; ) iex&gt; Jason . decode! ( body ) [ &quot;form&quot; ] %{ &quot;some-value&quot; =&gt; &quot;true&quot; } iex&gt; ExCurl . post ( &quot;https:// \\n \\n &quot; ) { :error , &quot;URL_MALFORMAT&quot; }","ref":"ExCurl.html#post/2","title":"ExCurl.post/2","type":"function"},{"doc":"Sends a PUT request to the given url . Similar to put/2 but raises ExCurl.CurlError if the request fails. See the &quot;Shared options&quot; section at the module documentation for available options and their defaults. Examples iex&gt; ExCurl . put! ( &quot;https://httpbin.org/put&quot; , headers : %{ &quot;content-type&quot; =&gt; &quot;application/json&quot; } , body : &quot;{}&quot; )","ref":"ExCurl.html#put!/2","title":"ExCurl.put!/2","type":"function"},{"doc":"Sends a PUT request to the given url . Returns either {:ok, %ExCurl.Response{}} or {:error, &quot;CURL_ERROR_MESSAGE&quot;} . See the &quot;Shared options&quot; section at the module documentation for available options and their defaults. See the &quot;Error messages&quot; section for details on error messages. Examples iex&gt; ExCurl . put ( &quot;https://httpbin.org/put&quot; , body : &quot;some-value=true&quot; )","ref":"ExCurl.html#put/2","title":"ExCurl.put/2","type":"function"},{"doc":"Sends a request to the given url using the provided method and options. Similar to request/3 but raises ExCurl.CurlError if the request fails. See the &quot;Shared options&quot; section at the module documentation for available options and their defaults.","ref":"ExCurl.html#request!/3","title":"ExCurl.request!/3","type":"function"},{"doc":"Send a request to the url using the provided method and options Returns either {:ok, %ExCurl.Response{}} or {:error, &quot;CURL_ERROR_MESSAGE&quot;} . See the &quot;Shared options&quot; section at the module documentation for available options and their defaults. See the &quot;Error messages&quot; section for details on error messages. Examples iex&gt; ExCurl . request ( &quot;GET&quot; , &quot;https://google.com&quot; ) iex&gt; ExCurl . request ( &quot;POST&quot; , &quot;https://google.com&quot; )","ref":"ExCurl.html#request/3","title":"ExCurl.request/3","type":"function"},{"doc":"A helper to create HTTP Clients based on ExCurl that can share common options. Example HTTP Client You can use ExCurl.Client on any module to provide HTTP Client functionality and share default options. Below is an example based on the great Tesla documentation : defmodule GitHubClient do use ExCurl.Client , defaults : [ base_url : &quot;https://api.github.com&quot; , headers : %{ &quot;authentication&quot; =&gt; &quot;Bearer some-secret-token&quot; } ] def user_repos ( username ) , do : get ( &quot;/users/ \#{ username } /repos&quot; ) end We can then use this client with the shared defaults and custom functions: # A custom GET request using our default base_url and headers GitHubClient . get ( &quot;/users/danielrudn&quot; ) # Our custom function, requiring only a username GitHubClient . user_repos ( &quot;danielrudn&quot; ) Response Handling You may define an optional handle_response/1 callback to transform a response after a successful request. A common example would be parsing a JSON string into a map. Below we have the same GitHub client as above but we also parse the JSON response if possible using the handle_response/1 callback: defmodule GitHubClient do use ExCurl.Client , defaults : [ base_url : &quot;https://api.github.com&quot; , headers : %{ &quot;authentication&quot; =&gt; &quot;Bearer some-secret-token&quot; } ] def handle_response ( % ExCurl.Response { body : body } ) do case Jason . decode ( body ) do { :ok , decoded_body } -&gt; decoded_body _ -&gt; body end end def user_repos ( username ) , do : get ( &quot;/users/ \#{ username } /repos&quot; ) end Options All of the Shared Options from ExCurl are available. There are also the following additional options: base_url - The base URL used for all requests by this client module","ref":"ExCurl.Client.html","title":"ExCurl.Client","type":"behaviour"},{"doc":"See Response Handling for usage and examples.","ref":"ExCurl.Client.html#c:handle_response/1","title":"ExCurl.Client.handle_response/1","type":"callback"},{"doc":"Helper functions to map curl error codes from their integer value to the string value and vice versa.","ref":"ExCurl.CurlErrorCodes.html","title":"ExCurl.CurlErrorCodes","type":"module"},{"doc":"Returns the integer code for the corresponding string error message. Returns -1 if the message is not a valid curl error code. Examples iex&gt; ExCurl.CurlErrorCodes . get_code ( &quot;URL_MALFORMAT&quot; ) 3 iex&gt; ExCurl.CurlErrorCodes . get_code ( &quot;DOESN&#39;T EXIST&quot; ) - 1","ref":"ExCurl.CurlErrorCodes.html#get_code/1","title":"ExCurl.CurlErrorCodes.get_code/1","type":"function"},{"doc":"Returns the string message for a coresponding integer error code. Returns &quot;CODE_OUT_OF_RANGE if the value is not a valid curl error code. Examples iex&gt; ExCurl.CurlErrorCodes . get_message ( 3 ) &quot;URL_MALFORMAT&quot; iex&gt; ExCurl.CurlErrorCodes . get_message ( 256 ) &quot;CODE_OUT_OF_RANGE&quot;","ref":"ExCurl.CurlErrorCodes.html#get_message/1","title":"ExCurl.CurlErrorCodes.get_message/1","type":"function"},{"doc":"A valid response returned by ExCurl. Metrics When the metrics_returned field is set to true , the following metrics will be included: total_time - corresponds to the CURLINFO_TOTAL_TIME_T option . namelookup_time - corresponds to the CURLINFO_NAMELOOKUP_TIME_T option . connect_time - corresponds to the CURLINFO_CONNECT_TIME_T option . appconnect_time - corresponds to the CURLINFO_APPCONNECT_TIME_T option . pretransfer_time - corresponds to the CURLINFO_PRETRANSFER_TIME_T option . starttransfer_time - corresponds to the CURLINFO_STARTTRANSFER_TIME_T option .","ref":"ExCurl.Response.html","title":"ExCurl.Response","type":"module"},{"doc":"","ref":"ExCurl.Response.html#t:t/0","title":"ExCurl.Response.t/0","type":"type"},{"doc":"This module wraps the use Zig macro to allow multiplatform compilation of Zig code that imports libcurl. The current implementation naively guesses standard libcurl locations based on the @load_order module attribute.","ref":"ExCurl.Zig.MultiPlatformCurl.html","title":"ExCurl.Zig.MultiPlatformCurl","type":"module"},{"doc":"","ref":"ExCurl.CurlError.html","title":"ExCurl.CurlError","type":"exception"},{"doc":"","ref":"ExCurl.Request.ZigError.html","title":"ExCurl.Request.ZigError","type":"exception"},{"doc":"Callback implementation for Exception.blame/2 .","ref":"ExCurl.Request.ZigError.html#blame/2","title":"ExCurl.Request.ZigError.blame/2","type":"function"},{"doc":"Elixir bindings for libcurl using Zig's C interoperability.","ref":"readme.html","title":"ExCurl","type":"extras"},{"doc":"ExCurl . get ( &quot;https://httpbin.org/get&quot; ) # =&gt; {:ok, %ExCurl.Response{status_code: 200, headers: %{&quot;content-type&quot; =&gt; &quot;application/json&quot;, body: &quot;{...}&quot;}}} # view request metrics ExCurl . get! ( &quot;https://httpbin.org/get&quot; , return_metrics : true ) # =&gt; %ExCurl.Response{status_code: 200, total_time: 0.2, namelookup_time: 0.01, appconnect_time: 0.05, ...}} # submit a form ExCurl . post ( &quot;https://httpbin.org/post&quot; , body : &quot;text= \#{ URI . encode_www_form ( &quot;some value&quot; ) } &quot; ) # =&gt; {:ok, %ExCurl.Response{status_code: 200, body: &quot;{...}&quot;}}} General usage examples and documentation can be found on the ExCurl module documentation page . HTTP Clients and Shared Defaults # create clients and set default options defmodule CustomClient do use ExCurl.Client , defaults : [ headers : %{ &quot;User-Agent&quot; =&gt; &quot;custom-user-agent&quot; } ] end # all requests using CustomClient will use the custom User-Agent header CustomClient . get ( &quot;https://httpbin.org/get&quot; ) # =&gt; {:ok, %ExCurl.Response{status_code: 200, body: &quot;..&quot;}} You can use ExCurl.Client on any module to create HTTP Clients. Below is an example of a GitHub API client based on the great Tesla documentation : defmodule GitHubClient do use ExCurl.Client , defaults : [ base_url : &quot;https://api.github.com&quot; ] def user_repos ( username ) , do : get ( &quot;/users/ \#{ username } /repos&quot; ) end # we can now call the GitHubClient with the pre-defined HTTP verb functions: GitHubClient . get ( &quot;/users/danielrudn/repos&quot; ) # =&gt; {:ok, %ExCurl.Response{status_code: 200, body: &quot;{....}&quot;}} # or call our custom defined functions: GitHubClient . user_repos ( &quot;danielrudn&quot; ) # =&gt; {:ok, %ExCurl.Response{status_code: 200, body: &quot;{....}&quot;}} More examples and details on using ExCurl.Client are available on the ExCurl.Client module documentation page .","ref":"readme.html#usage","title":"ExCurl - Usage","type":"extras"},{"doc":"The package can be installed by adding ex_curl to your list of dependencies in mix.exs : def deps do [ { :ex_curl , &quot;~&gt; 0.2.0&quot; } ] end","ref":"readme.html#installation","title":"ExCurl - Installation","type":"extras"},{"doc":"Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/ex_curl .","ref":"readme.html#documentation","title":"ExCurl - Documentation","type":"extras"},{"doc":"This library is built on top of libcurl as a NIF using Zigler and Zig's C interoperability . Inspired by Tesla , Katipo , and Req .","ref":"readme.html#acknowledgements","title":"ExCurl - Acknowledgements","type":"extras"},{"doc":"MIT License Copyright (c) 2022 Daniel Rudnitski Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]